/*
 * demo.cpp
 *
 * Created: 02.02.2016 10:02:42
 *  Author: ms68686
 */ 
// UTFT_Demo_320x240_Serial
// Copyright (C)2015 Rinky-Dink Electronics, Henning Karlsen. All right reserved
// web: http://www.RinkyDinkElectronics.com/
//
// This program is a demo of how to use most of the functions
// of the library with a supported display modules.
//
// This demo was made for serial modules with a screen
// resolution of 320x240 pixels.
//
// This program requires the UTFT library.
//
// ********************************************************************
// * IMPORTANT: Read the comments in the setup() function when        *
// * using the Watterott MI0283QT9 or the DisplayModule DM-TFT28-105. *
// ********************************************************************
//

#include "UTFT.h"
#include "SPILibrary.h"
#include "initlcd.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/delay.h>
#include <inttypes.h>
#include <stdbool.h>
#include <stdlib.h>

// Declare which fonts we will be using
extern uint8_t SmallFont[];

// Uncomment the line for your display:
//UTFT myGLCD(MI0283QT9,11,13,7,8);                // Watterott MI0283QT9
//UTFT myGLCD(DMTFT28105,MOSI,SCK,10,NOTINUSE,9);  // DisplayModule DM-TFT28-105 (Works with both Arduino Uno and Arduino Mega)
//UTFT myGLCD(TFT01_22SP,9,8,12,11,10);            // ElecFreaks TFT01-2.2SP
//UTFT myGLCD(TFT01_24SP,9,8,12,11,10);            // ElecFreaks TFT01-2.4SP
UTFT myGLCD;                  // ElecFreaks TFT2.2SP Shield //(ILI9341_S4P,3,4,7,5,6);

void setup()
{
	// Watterott
	// ---------
	// The following two lines are needed for the MI0283QT9 display
	// module to enable the backlight. If you are using any other
	// display module these lines should be commented out.
	// -------------------------------------------------------------
	//  pinMode(9, OUTPUT);
	//  digitalWrite(9, HIGH);
	// -------------------------------------------------------------

	// DisplayModule
	// -------------
	// The following 4 lines are needed for the DM-TFT28-105 display
	// module to set the SS/CS pins for the other devices connected
	// to the Arduino SPI pins. If you are using any other display
	// module these lines should be commented out.
	// -------------------------------------------------------------
	//  pinMode(10,OUTPUT); digitalWrite(10,HIGH);  // TFT SS/CE
	//  pinMode(8, OUTPUT); digitalWrite(8, HIGH);  // SD card SS/CE
	//  pinMode(6, OUTPUT); digitalWrite(6, HIGH);  // Flash chip SS/CE
	//  pinMode(4, OUTPUT); digitalWrite(4, HIGH);  // Touch controller SS/CE
	// -------------------------------------------------------------


	// Just get some rand numbers
	//randSeed(analogRead(0));
	// Setup the LCD
	myGLCD.InitLCD();
	myGLCD.setFont(SmallFont);
	
}



int main(void)
{
		myGLCD.InitLCD();
		myGLCD.setFont(SmallFont);
    /* Replace with your application code */
    while (1) 
    {
		int buf[318];
	    int x1, x2;
	    int y1, y2;
	    int r;
 		SPI.SPI_init();
 		myGLCD.InitLCD();

	    // Clear the screen and draw the frame
	    myGLCD.clrScr();
	    myGLCD.setColor(255, 0, 0);
		myGLCD.drawRect(100,100,200,200);
		_delay_ms(20);
	    myGLCD.fillRect(0, 0, 319, 13);
	    myGLCD.setColor(64, 64, 64);
	    myGLCD.fillRect(0, 226, 319, 239);
	    myGLCD.setColor(255, 255, 255);
	    myGLCD.setBackColor(255, 0, 0);
	    //myGLCD.print("* Universal Color TFT Display Library *", CENTER, 1);
	    myGLCD.setBackColor(64, 64, 64);
	    myGLCD.setColor(255,255,0);
	    //myGLCD.print("<http://www.RinkyDinkElectronics.com/>", CENTER, 227);
		// Draw some filled circles
		for (int i=1; i<6; i++)
		{
			switch (i)
			{
				case 1:
				myGLCD.setColor(255,0,255);
				break;
				case 2:
				myGLCD.setColor(255,0,0);
				break;
				case 3:
				myGLCD.setColor(0,255,0);
				break;
				case 4:
				myGLCD.setColor(0,0,255);
				break;
				case 5:
				myGLCD.setColor(255,255,0);
				break;
			}
			myGLCD.fillCircle(100+(i*20),60+(i*20), 30);
		}
    }
//	return 0;
}

