// 
// 
// 

#include "ownTEXT.h"
#include "SPILibrary.h"
#include "UTFT.h"
#include <avr/io.h>
#include <stdlib.h>

// OwnTEXTClass::OwnTEXTClass(DisplayLibrary *tftCore)
// {	
// 	tft = tftCore;
// 
// 	_x = 20;
//	_y = 250;
// 	
// 	_letterSpacing = 2;
//	_isLastChar = false;
// 
// }

OwnTEXTClass::OwnTEXTClass()
{
	tft = 0;

	_x = 20;
	_y = 250;
	
	_letterSpacing = 2;
	_isLastChar = false;
	
}


void OwnTEXTClass::puts(const char *str)
{
	while(*str)
	{
		if(*(str+1) == 0)
		_isLastChar = true;
		putChar((uint8_t)*str);
		str++;
	}
	_isLastChar = false;
}


void OwnTEXTClass::puts_progmem(const char *str)
{
	
	uint8_t tmp = 0;
	
	while(pgm_read_byte(&(str[tmp])))
	{
		if(pgm_read_byte(&(str[tmp+1])) == 0)
		_isLastChar = true;
		putChar(pgm_read_byte(&(str[tmp])));
		tmp++;
	}
	_isLastChar = false;
}

// void OwnTEXTClass::puts(const String &str)
// {
// 	for (int i = 0; i < str.length(); i++)
// 	{
// 		putChar(str[i]);
// 	}
// }


// void OwnTEXTClass::print(String &str, int16_t x, int16_t y)
// {
// 	_x = x;
// 	_y = y;
// 	puts(str);
// }

void OwnTEXTClass::print(const char *str, int16_t x, int16_t y)
{
	_x = x;
	_y = y;
	puts(str);
}

void OwnTEXTClass::print_progmem(const char *str, int16_t x, int16_t y)
{
		_x = x;
		_y = y;
		puts_progmem(str);
}




int OwnTEXTClass::putChar(uint8_t c)
{
	if(_font == 0)
	{
		//Serial.println(F("No font selected"));
		return 0; // no font selected
	}



	uint16_t charWidth = 0;
	uint16_t charHeight = fontHeight();
	uint8_t charHeightInBytes = (charHeight+7)/8; // calculates height in rounded up bytes 

	uint8_t firstChar = pgm_read_byte(_font+GTEXT_FONT_FIRST_CHAR);
	uint8_t charCount = pgm_read_byte(_font+GTEXT_FONT_CHAR_COUNT);

	uint16_t index = 0;
	//uint8_t thielefont;

	if(c < firstChar || c >= (firstChar+charCount)) {
		return 0; // invalid char
	}
	c-= firstChar;

	if( isFixedWidthFont(_font) {
		//thielefont = 0;
		charWidth = pgm_read_byte(_font+GTEXT_FONT_FIXED_WIDTH); 
		index = c*charHeightInBytes*charWidth+GTEXT_FONT_WIDTH_TABLE;
	}
	else{
		// variable width font, read width data, to get the index
		//thielefont = 1;
		/*
		* Because there is no table for the offset of where the data
		* for each character glyph starts, run the table and add up all the
		* widths of all the characters prior to the character we
		* need to locate.
		*/
		for(uint8_t i=0; i<c; i++) {  
			index += pgm_read_byte(_font+GTEXT_FONT_WIDTH_TABLE+i);
		}
		/*
		* Calculate the offset of where the font data
		* for our character starts.
		* The index value from above has to be adjusted because
		* there is potentialy more than 1 byte per column in the glyph,
		* when the characgter is taller than 8 bits.
		* To account for this, index has to be multiplied
		* by the height in bytes because there is one byte of font
		* data for each vertical 8 pixels.
		* The index is then adjusted to skip over the font width data
		* and the font header information.
		*/

		index = index*charHeightInBytes+charCount+GTEXT_FONT_WIDTH_TABLE;

		/*
		* Finally, fetch the width of our character
		*/
		charWidth = pgm_read_byte(_font+GTEXT_FONT_WIDTH_TABLE+c);
	}

	drawSolidChar(c, index, charWidth, charHeight);

	return 1; // valid char
}

void OwnTEXTClass::drawSolidChar(char c, uint16_t index, uint16_t charWidth, uint16_t charHeight)
{
	uint8_t bitId=0;
	//
	int16_t cx = _x; //_x
	int16_t cy = _y; //_y

	uint8_t charHeightInBytes = (charHeight+7)/8; /* calculates height in rounded up bytes */

	uint16_t lineId=0;
	uint8_t numRenderBits = 8;
	const uint8_t numRemainingBits = charHeight % 8;
	//_ili->enableCS();
	for(uint16_t j=0; j<charWidth; j++) /* each column */
	{
		//Serial << "Printing row" << endl;
		lineId = 0;
		numRenderBits = 8;
		tft->setXY(cx, cy, cx, cy+charHeight -1);
		
		CS_TFT_LOW;
		DC_TFT_HIGH;
		for(uint8_t i=0; i<charHeightInBytes; i++)	/* each vertical byte */
		{
			uint16_t page = i*charWidth; // page must be 16 bit to prevent overflow
			uint8_t data = pgm_read_byte(_font+index+page+j);

			/*
			* This funkyness is because when the character glyph is not a
			* multiple of 8 in height, the residual bits in the font data
			* were aligned to the incorrect end of the byte with respect 
			* to the GLCD. I believe that this was an initial oversight (bug)
			* in Thieles font creator program. It is easily fixed
			* in the font program but then creates a potential backward
			* compatiblity problem.
			*	--- bperrybap
			*/
			if(charHeight > 8 && charHeight < (i+1)*8)	/* is it last byte of multibyte tall font? */
			{
				data >>= ((i+1) << 3) - charHeight;	// (i+1)*8
			}
			//Serial << "data:" <<data << " x:" << cx << " y:" << cy << endl;
			//Serial.print("data:");Serial.print(data);Serial.print(" x:");Serial.print(cx);Serial.print(" y:");Serial.println(cy);

			if(i == charHeightInBytes - 1)	// last byte in column
				numRenderBits = numRemainingBits;

			for( bitId = 0; bitId < numRenderBits; bitId++ )
			{
				if ( (data & 0x01) == 0 )
				{
				
				SPI.SPI_transfer(tft->getBackColor()>>8);
				SPI.SPI_transfer(tft->getBackColor());
				

				}
				else
				{
				SPI.SPI_transfer(tft->getColor()>>8);
				SPI.SPI_transfer(tft->getColor());
				

				}
				data>>=1;
			} 
			//_delay_ms(50);
		}
		//Serial << endl;
		cx++;


	}
	CS_TFT_HIGH;	// to put CS line back up

	_x += charWidth;

	//Serial << " ending at " << _x  << " lastChar " << _lastChar <<endl;

	if(_letterSpacing > 0 && !_isLastChar)
	{
		uint16_t currentColor = tft->getColor();
		tft->setColor(tft->getBackColor());
		tft->fillRect(_x,_y,_x+_letterSpacing,_y+charHeight-1);
		//tft->fillRect(_x, _y, _letterSpacing, charHeight, tft->getBackColor());
		_x+=_letterSpacing;
		
		tft->setColor(currentColor);
	}
	//Serial << "letterSpacing " << _letterSpacing <<" x: " << _x <<endl;
}

uint16_t OwnTEXTClass::charWidth(uint8_t c)
{
	int16_t width = 0;

	if(isFixedWidthFont(_font){
		width = pgm_read_byte(_font+GTEXT_FONT_FIXED_WIDTH);
	}
	else{
		// variable width font
		uint8_t firstChar = pgm_read_byte(_font+GTEXT_FONT_FIRST_CHAR);
		uint8_t charCount = pgm_read_byte(_font+GTEXT_FONT_CHAR_COUNT);

		// read width data
		if(c >= firstChar && c < (firstChar+charCount)) {
			c -= firstChar;
			width = pgm_read_byte(_font+GTEXT_FONT_WIDTH_TABLE+c);
			//Serial << "strWidth of " << c << " : " << width << endl;
		}
	}
	return width;
}

uint16_t OwnTEXTClass::stringWidth(const char* str)
{
	uint16_t width = 0;

	while(*str != 0) {
		width += charWidth(*str++) + _letterSpacing;
	}
	if(width > 0)
	width -= _letterSpacing;
	return width;
}

// uint16_t OwnTEXTClass::stringWidth(String &str)
// {
// 	uint16_t width = 0;
// 
// 	for (int i = 0; i < str.length(); i++)
// 	{
// 		width += charWidth(str[i]) + _letterSpacing;
// 	}
// 	width -= _letterSpacing;
// 	return width;
// }


void OwnTEXTClass::printNumI(long num, int x, int y, int length, char filler)
{
	char buf[25];
	char st[27];
	bool neg=false;
	int c=0, f=0;
	
	_x = x;
	_y = y;
	
	if (num==0)
	{
		if (length!=0)
		{
			for (c=0; c<(length-1); c++)
			st[c]=filler;
			st[c]=48;
			st[c+1]=0;
		}
		else
		{
			st[0]=48;
			st[1]=0;
		}
	}
	else
	{
		if (num<0)
		{
			neg=true;
			num=-num;
		}
		
		while (num>0)
		{
			buf[c]=48+(num % 10);
			c++;
			num=(num-(num % 10))/10;
		}
		buf[c]=0;
		
		if (neg)
		{
			st[0]=45;
		}
		
		if (length>(c+neg))
		{
			for (int i=0; i<(length-c-neg); i++)
			{
				st[i+neg]=filler;
				f++;
			}
		}

		for (int i=0; i<c; i++)
		{
			st[i+neg+f]=buf[c-i-1];
		}
		st[c+neg+f]=0;

	}

	
		
	puts(st);
	

}


void OwnTEXTClass::printNumF(double num, uint8_t dec, int x, int y, char divider, int length, char filler)
{
	char st[27] = {"12345678901234567890  :"};
	bool neg=false;
	
	_x = x;
	_y = y;

	if (dec<1)
	dec=1;
	else if (dec>5)
	dec=5;

	if (num<0)
	neg = true;

	

	//_convert_float(st, num, length, dec);
	
// 		Serial.print("\n");
// 		Serial.print("test");
// 		Serial.print(st);
// 		Serial.printInteger((int)num);

	dtostrf(num,length,dec,st);	
	


	if (divider != '.')
	{
		for (int i=0; i<sizeof(st); i++)
		if (st[i]=='.')
		st[i]=divider;
	}

	if (filler != ' ')
	{
		if (neg)
		{
			st[0]='-';
			for (int i=1; i<sizeof(st); i++)
			if ((st[i]==' ') || (st[i]=='-'))
			st[i]=filler;
		}
		else
		{
			for (int i=0; i<sizeof(st); i++)
			if (st[i]==' ')
			st[i]=filler;
		}
	}


	puts(st);
}