// ownTEXT.h

#ifndef _OWNTEXT_h
#define _OWNTEXT_h


	
#include "UTFT.h"
	
//#include <stdlib.h>
#include <stdio.h>
//#include "uart.h"


// Font Indices
#define GTEXT_FONT_LENGTH			0
#define GTEXT_FONT_FIXED_WIDTH	2
#define GTEXT_FONT_HEIGHT			3
#define GTEXT_FONT_FIRST_CHAR		4
#define GTEXT_FONT_CHAR_COUNT		5
#define GTEXT_FONT_WIDTH_TABLE	6

typedef const uint8_t* gTextFont;

#define isFixedWidthFont(font)  (pgm_read_byte(font+GTEXT_FONT_LENGTH) == 0 && pgm_read_byte(font+GTEXT_FONT_LENGTH+1) == 0))

class OwnTEXTClass
{
 private:
 
	UTFT *tft;
	gTextFont _font;
	int16_t	_x;
	int16_t	_y;
	
	uint8_t _letterSpacing;
	bool _isLastChar;
	
	uint8_t fontHeight()	{
		return pgm_read_byte(_font+GTEXT_FONT_HEIGHT);
	};
	
	void puts(const char *str);
	void puts_progmem(const char *str);
	//void puts(const String &str);
	int putChar(uint8_t c);
	void drawSolidChar(char c, uint16_t index, uint16_t charWidth, uint16_t charHeight);
	
	//void _convert_float(char *buf, double num, int width, byte prec);
	

	
 public:
 
	uint16_t charWidth(uint8_t c);
	uint16_t stringWidth(const char* str);
	//uint16_t stringWidth(String &str);
 
//	OwnTEXTClass(DisplayLibrary *tftCore);
	OwnTEXTClass();
	
	void setTftCore(UTFT *tftCore){tft = tftCore;}
	
	
	void printNumI(long num, int x, int y, int length=0, char filler=' ');
	void printNumF(double num, uint8_t dec, int x, int y, char divider='.', int length=0, char filler=' ');
	
	//void print(String &str, int16_t x, int16_t y);
	void print(const char *str, int16_t x, int16_t y);
	void print_progmem(const char *str, int16_t x, int16_t y);
	
	
	void setFont(gTextFont font){_font = font;}
	gTextFont getFont(){return _font;}
	
	
};



#endif

